<script setup lang="ts">
    import { Intervention } from '@/elusServiceOffer/entities/intervention/Intervention'
    import { getAnteriorityString } from '@/shared/helpers/dates'
    import { ref } from 'vue'

    interface Props {
        intervention: Intervention
        closeInterventionDetails: () => void
    }

    const props = defineProps<Props>()

    const intervention = ref<Intervention>(props.intervention)

    const formatDate = (interventionDate: Date | string): string => {
        const date = new Date(interventionDate)
        const day = date.getDate().toString().padStart(2, '0')
        const month = (date.getMonth() + 1).toString().padStart(2, '0')
        const year = date.getFullYear()
        const hours = date.getHours().toString().padStart(2, '0')
        const minutes = date.getMinutes().toString().padStart(2, '0')

        return `${day}/${month}/${year} ${hours}:${minutes}`
    }

    const isPropertyUndefined = <T extends keyof Intervention>(
        value: Intervention[T]
    ): boolean => {
        return value === undefined
    }
</script>

<template>
    <v-card :elevation="0">
        <div class="d-flex justify-space-between ma-4 mb-0">
            <v-btn
                icon="mdi-close"
                variant="text"
                color="on-background"
                density="compact"
                class="ml-auto"
                @click="props.closeInterventionDetails"
            ></v-btn>
        </div>

        <v-card-title class="font-weight-bold text-wrap text-capitalize pt-0">{{
            intervention.title
        }}</v-card-title>

        <v-card-item>
            <div class="d-flex flex-wrap">
                <div class="mr-3 mb-3">
                    <v-icon>mdi-clock-outline</v-icon>
                    {{ getAnteriorityString(intervention.createdAt) }}
                </div>

                <div class="mr-3 mb-3">
                    <v-icon>mdi-tag-outline</v-icon>
                    {{ intervention.currentStatus }}
                </div>

                <div v-if="$vuetify.display.mdAndUp" class="mr-3 mb-3">
                    <v-icon>mdi-pound</v-icon>
                    <a
                        :href="intervention.linkToCarl"
                        target="_blank"
                        rel="noopener noreferrer"
                        class="text-decoration-none"
                    >
                        {{ intervention.code }}
                    </a>
                </div>
                <div v-else class="mr-3 mb-3">
                    <v-icon>mdi-pound</v-icon>
                    {{ intervention.code }}
                </div>
            </div>

            <div class="d-flex flex-wrap">
                <div class="mr-3 mb-3">
                    <v-icon>mdi-calendar-start-outline</v-icon>
                    Début : {{ formatDate(intervention.beginDate) }}
                </div>
                <div class="mr-3 mb-3">
                    <v-icon>mdi-calendar-end-outline</v-icon>
                    Fin : {{ formatDate(intervention.endDate) }}
                </div>
            </div>

            <div class="d-flex flex-wrap">
                <div
                    class="mr-3 mb-3"
                    :class="{
                        'font-italic': isPropertyUndefined(
                            intervention.regroupment
                        ),
                    }"
                >
                    <v-icon>mdi-office-building-outline</v-icon>
                    {{ intervention.regroupment ?? 'Regroupement inconnu' }}
                </div>
            </div>

            <div class="d-flex flex-wrap">
                <div class="mr-3 mb-3">
                    <v-icon>mdi-map-marker-outline</v-icon>
                    {{ intervention.localisation }}
                </div>
            </div>

            <div class="d-flex flex-wrap">
                <div
                    class="mr-3 mb-3"
                    :class="{
                        'font-italic': isPropertyUndefined(
                            intervention.createdBy
                        ),
                    }"
                >
                    <v-icon>mdi-account-plus-outline</v-icon>
                    {{
                        `Emetteur ${
                            intervention.createdBy
                                ? ` : ${intervention.createdBy}`
                                : 'inconnu'
                        }`
                    }}
                </div>
            </div>

            <div class="d-flex flex-wrap">
                <div
                    class="mr-3 mb-3"
                    :class="{
                        'font-italic': isPropertyUndefined(
                            intervention.comment
                        ),
                    }"
                >
                    <v-icon>mdi-message-outline</v-icon>
                    {{ intervention.comment ?? 'Aucun commentaire' }}
                </div>
            </div>
        </v-card-item>

        <v-img
            v-if="intervention.imageUrl"
            max-height="400"
            cover
            :src="intervention.imageUrl.href"
        />

        <v-card-item>
            <v-timeline v-if="intervention.history" side="end" align="start">
                <v-timeline-item
                    v-for="history in intervention.history
                        .sort(
                            (a, b) =>
                                new Date(b.statusChangedAt).getTime() -
                                new Date(a.statusChangedAt).getTime()
                        )
                        .sort((a, b) => {
                            if (a.isCurrentStatus === b.isCurrentStatus) {
                                return 0
                            } else if (a.isCurrentStatus) {
                                return -1
                            } else {
                                return 1
                            }
                        })"
                    :key="history.id"
                    :dot-color="
                        history.isCurrentStatus ? 'primary' : 'disabled'
                    "
                    size="small"
                >
                    <div>
                        <div>
                            <strong>{{ history.currentStatus }}</strong>
                            <div class="text-caption">
                                {{
                                    history.createdBy
                                        ? history.createdBy
                                        : 'Inconnu'
                                }}
                                |
                                {{ formatDate(history.statusChangedAt) }}
                            </div>
                        </div>
                    </div>
                </v-timeline-item>
            </v-timeline>
        </v-card-item>
    </v-card>
</template>
